#ifndef __WEBNODE
#define __WEBNODE

#include <strstream.h>
#include <iostream.h>
#include "sockinet.h"
#include "URL.h"
#include "cache.h"

class WebNode
{
public:
  WebNode( const char* location ) 
  { 
    intStatus = 1;
    if( ! cache.isCached( location ) )
      {
	download( location ); 
#ifdef DEBUG
	cerr << "WebNode: put into cache\n";
#endif
	cache.cacheIt( location, dataBuf, dataSize );
      }
    else
      {
#ifdef DEBUG
	cerr << "WebNode: retrieved from cache\n";
#endif
	dataBuf = cache.getBuffer();
	dataSize = cache.getBufferSize();
      }
  }
  
  ~WebNode() { }
  void download( const char* location );
  char* getBuffer() { return dataBuf; }
  int getBufSize() const { return dataSize; } 
  int isOK() const { return intStatus; }
  operator void* () { return ( void* )intStatus; }
  char* getErrMsg() { return errMsg; }

private:
  void throwMsg( const char* msg1, const char* msg2 )
  { intStatus = 0; sprintf( errMsg, "%s: %s\n", msg1, msg2 ); }
  char* dataBuf;
  char errMsg[256];
  int dataSize;
  int intStatus;

  static Cache cache;
};

#endif
